## GtkApplication GtkApplication — Application class |

## Functions

GtkApplication * | gtk_application_new ()
void | gtk_application_add_window ()
void | gtk_application_remove_window ()
GList * | gtk_application_get_windows ()
GtkWindow * | gtk_application_get_window_by_id ()
GtkWindow * | gtk_application_get_active_window ()
guint | gtk_application_inhibit ()
void | gtk_application_uninhibit ()
gboolean | gtk_application_is_inhibited ()
GMenuModel * | gtk_application_get_app_menu ()
void | gtk_application_set_app_menu ()
GMenuModel * | gtk_application_get_menubar ()
void | gtk_application_set_menubar ()
void | gtk_application_add_accelerator ()
void | gtk_application_remove_accelerator ()
gchar ** | gtk_application_list_action_descriptions ()
gchar ** | gtk_application_get_accels_for_action ()
void | gtk_application_set_accels_for_action ()

## Properties

GtkWindow * | active-window | Read
GMenuModel * | app-menu | Read / Write
GMenuModel * | menubar | Read / Write
gboolean | register-session | Read / Write

## Signals

void | window-added | Run First
void | window-removed | Run First

## Types and Values

struct | GtkApplication
struct | GtkApplicationClass
enum | GtkApplicationInhibitFlags

## Object Hierarchy

        GObject
        ╰── GApplication
            ╰── GtkApplication

## Implemented Interfaces

GtkApplication implements GActionGroup and GActionMap.

## Includes

    #include <gtk/gtk.h>

## Description

GtkApplication is a class that handles many important aspects of a GTK+ application in a convenient fashion, without enforcing a one-size-fits-all application model.

Currently, GtkApplication handles GTK+ initialization, application uniqueness, session management, provides some basic scriptability and desktop shell integration by exporting actions and menus and manages a list of toplevel windows whose life-cycle is automatically tied to the life-cycle of your application.

While GtkApplication works fine with plain GtkWindows, it is recommended to use it together with GtkApplicationWindow.

When GDK threads are enabled, GtkApplication will acquire the GDK lock when invoking actions that arrive from other processes. The GDK lock is not touched for local action invocations. In order to have actions invoked in a predictable context it is therefore recommended that the GDK lock be held while invoking actions locally with `g_action_group_activate_action()`. The same applies to actions associated with GtkApplicationWindow and to the “activate” and 'open' GApplication methods.

To set an application menu for a GtkApplication, use `gtk_application_set_app_menu()`. The GMenuModel that this function expects is usually constructed using GtkBuilder, as seen in the following example. To specify a menubar that will be shown by GtkApplicationWindows, use `gtk_application_set_menubar()`. Use the base GActionMap interface to add actions, to respond to the user selecting these menu items.

GTK+ displays these menus as expected, depending on the platform the application is running on.

#### A simple application

A simple example

GtkApplication optionally registers with a session manager of the users session (if you set the “register-session” property) and offers various functionality related to the session life-cycle.

An application can block various ways to end the session with the `gtk_application_inhibit()` function. Typical use cases for this kind of inhibiting are long-running, uninterruptible operations, such as burning a CD or performing a disk backup. The session manager may not honor the inhibitor, but it can be expected to inform the user about the negative consequences of ending the session while inhibitors are present.

## Functions

### gtk_application_new ()

    GtkApplication *
    gtk_application_new (const gchar *application_id,
                         GApplicationFlags flags);

Creates a new GtkApplication instance.

When using GtkApplication, it is not necessary to call `gtk_init()` manually. It is called as soon as the application gets registered as the primary instance.

Concretely, `gtk_init()` is called in the default handler for the “startup” signal. Therefore, GtkApplication subclasses should chain up in their “startup” handler before using any GTK+ API.

Note that commandline arguments are not passed to `gtk_init()`. All GTK+ functionality that is available via commandline arguments can also be achieved by setting suitable environment variables such as `G_DEBUG`, so this should not be a big problem. If you absolutely must support GTK+ commandline arguments, you can explicitly call `gtk_init()` before creating the application instance.

If non-`NULL`, the application ID must be valid. See `g_application_id_is_valid()`.

If no application ID is given then some features (most notably application uniqueness) will be disabled. A null application ID is only allowed with GTK+ 3.6 or later.

#### Parameters

application_id | The application ID. | [allow-none]
flags | the application flags |

#### Returns

a new GtkApplication instance

Since 3.0

### gtk_application_add_window ()

    void
    gtk_application_add_window (GtkApplication *application,
                                GtkWindow *window);

Adds a window to `application` .

This call is equivalent to setting the “application” property of `window` to `application` .

Normally, the connection between the application and the window will remain until the window is destroyed, but you can explicitly remove it with `gtk_application_remove_window()`.

GTK+ will keep the application running as long as it has any windows.

#### Parameters

application | a GtkApplication |
window | a GtkWindow |

Since 3.0

### gtk_application_remove_window ()

    void
    gtk_application_remove_window (GtkApplication *application,
                                   GtkWindow *window);

Remove a window from `application` .

If `window` belongs to `application` then this call is equivalent to setting the “application” property of `window` to `NULL`.

The application may stop running as a result of a call to this function.

#### Parameters

application | a GtkApplication |
window | a GtkWindow |

Since 3.0

### gtk_application_get_windows ()

    GList *
    gtk_application_get_windows (GtkApplication *application);

Gets a list of the GtkWindows associated with `application` .

The list is sorted by most recently focused window, such that the first element is the currently focused window. (Useful for choosing a parent for a transient window.)

The list that is returned should not be modified in any way. It will only remain valid until the next focus change or window creation or deletion.

#### Parameters

application | a GtkApplication |

#### Returns

a GList of GtkWindow.

[element-type GtkWindow][transfer none]

Since 3.0

### gtk_application_get_window_by_id ()

    GtkWindow *
    gtk_application_get_window_by_id (GtkApplication *application,
                                      guint id);

Returns the GtkApplicationWindow with the given ID.

#### Parameters

application | a GtkApplication |
id | an identifier number |

#### Returns

the window with ID `id` , or `NULL` if there is no window with this ID.

[transfer none]

Since 3.6

### gtk_application_get_active_window ()

    GtkWindow *
    gtk_application_get_active_window (GtkApplication *application);

Gets the “active” window for the application.

The active window is the one that was most recently focused (within the application). This window may not have the focus at the moment if another application has it -- this is just the most recently-focused window within this application.

#### Parameters

application | a GtkApplication |

#### Returns

the active window.

[transfer none]

Since 3.6

### gtk_application_inhibit ()

    guint
    gtk_application_inhibit (GtkApplication *application,
                             GtkWindow *window,
                             GtkApplicationInhibitFlags flags,
                             const gchar *reason);

Inform the session manager that certain types of actions should be inhibited. This is not guaranteed to work on all platforms and for all types of actions.

Applications should invoke this method when they begin an operation that should not be interrupted, such as creating a CD or DVD. The types of actions that may be blocked are specified by the `flags` parameter. When the application completes the operation it should call `gtk_application_uninhibit()` to remove the inhibitor. Note that an application can have multiple inhibitors, and all of the must be individually removed. Inhibitors are also cleared when the application exits.

Applications should not expect that they will always be able to block the action. In most cases, users will be given the option to force the action to take place.

Reasons should be short and to the point.

If `window` is given, the session manager may point the user to this window to find out more about why the action is inhibited.

#### Parameters

application | the GApplication |
window | a GtkWindow, or `NULL`. | [allow-none]
flags | what types of actions should be inhibited |
reason | a short, human-readable string that explains why these operations are inhibited. | [allow-none]

#### Returns

A non-zero cookie that is used to uniquely identify this request. It should be used as an argument to `gtk_application_uninhibit()` in order to remove the request. If the platform does not support inhibiting or the request failed for some reason, 0 is returned.

Since 3.4

### gtk_application_uninhibit ()

    void
    gtk_application_uninhibit (GtkApplication *application,
                               guint cookie);

Removes an inhibitor that has been established with `gtk_application_inhibit()`. Inhibitors are also cleared when the application exits.

#### Parameters

application | the GApplication |
cookie | a cookie that was returned by `gtk_application_inhibit()` |

Since 3.4

### gtk_application_is_inhibited ()

    gboolean
    gtk_application_is_inhibited (GtkApplication *application,
                                  GtkApplicationInhibitFlags flags);

Determines if any of the actions specified in `flags` are currently inhibited (possibly by another application).

#### Parameters

application | the GApplication |
flags | what types of actions should be queried |

#### Returns

`TRUE` if any of the actions specified in `flags` are inhibited

Since 3.4

### gtk_application_get_app_menu ()

    GMenuModel *
    gtk_application_get_app_menu (GtkApplication *application);

Returns the menu model that has been set with `gtk_application_set_app_menu()`.

#### Parameters

application | a GtkApplication |

#### Returns

the application menu of `application` .

[transfer none]

Since 3.4

### gtk_application_set_app_menu ()

    void
    gtk_application_set_app_menu (GtkApplication *application,
                                  GMenuModel *app_menu);

Sets or unsets the application menu for `application` .

This can only be done in the primary instance of the application, after it has been registered. “startup” is a good place to call this.

The application menu is a single menu containing items that typically impact the application as a whole, rather than acting on a specific window or document. For example, you would expect to see “Preferences” or “Quit” in an application menu, but not “Save” or “Print”.

If supported, the application menu will be rendered by the desktop environment.

Use the base GActionMap interface to add actions, to respond to the user selecting these menu items.

#### Parameters

application | a GtkApplication |
app_menu | a GMenuModel, or `NULL`. | [allow-none]

Since 3.4

### gtk_application_get_menubar ()

    GMenuModel *
    gtk_application_get_menubar (GtkApplication *application);

Returns the menu model that has been set with `gtk_application_set_menubar()`.

#### Parameters

application | a GtkApplication |

#### Returns

the menubar for windows of `application` .

[transfer none]

Since 3.4

### gtk_application_set_menubar ()

    void
    gtk_application_set_menubar (GtkApplication *application,
                                 GMenuModel *menubar);

Sets or unsets the menubar for windows of `application` .

This is a menubar in the traditional sense.

This can only be done in the primary instance of the application, after it has been registered. “startup” is a good place to call this.

Depending on the desktop environment, this may appear at the top of each window, or at the top of the screen. In some environments, if both the application menu and the menubar are set, the application menu will be presented as if it were the first item of the menubar. Other environments treat the two as completely separate -- for example, the application menu may be rendered by the desktop shell while the menubar (if set) remains in each individual window.

Use the base GActionMap interface to add actions, to respond to the user selecting these menu items.

#### Parameters

application | a GtkApplication |
menubar | a GMenuModel, or `NULL`. | [allow-none]

Since 3.4

### gtk_application_add_accelerator ()

    void
    gtk_application_add_accelerator (GtkApplication *application,
                                     const gchar *accelerator,
                                     const gchar *action_name,
                                     GVariant *parameter);

Installs an accelerator that will cause the named action to be activated when the key combination specificed by `accelerator` is pressed.

`accelerator` must be a string that can be parsed by `gtk_accelerator_parse()`, e.g. "<Primary>q" or “<Control><Alt>p”.

`action_name` must be the name of an action as it would be used in the app menu, i.e. actions that have been added to the application are referred to with an “app.” prefix, and window-specific actions with a “win.” prefix.

GtkApplication also extracts accelerators out of “accel” attributes in the GMenuModels passed to `gtk_application_set_app_menu()` and `gtk_application_set_menubar()`, which is usually more convenient than calling this function for each accelerator.

#### Parameters

application | a GtkApplication |
accelerator | accelerator string |
action_name | the name of the action to activate |
parameter | parameter to pass when activating the action, or `NULL` if the action does not accept an activation parameter. | [allow-none]

Since 3.4

### gtk_application_remove_accelerator ()

    void
    gtk_application_remove_accelerator (GtkApplication *application,
                                        const gchar *action_name,
                                        GVariant *parameter);

Removes an accelerator that has been previously added with `gtk_application_add_accelerator()`.

#### Parameters

application | a GtkApplication |
action_name | the name of the action to activate |
parameter | parameter to pass when activating the action, or `NULL` if the action does not accept an activation parameter. | [allow-none]

Since 3.4

### gtk_application_list_action_descriptions ()

    gchar **
    gtk_application_list_action_descriptions
                                   (GtkApplication *application);

Lists the detailed action names which have associated accelerators. See `gtk_application_set_accels_for_action()`.

#### Parameters

application | a GtkApplication |

#### Returns

a `NULL`-terminated array of strings, free with `g_strfreev()` when done.

[transfer full]

Since 3.12

### gtk_application_get_accels_for_action ()

    gchar **
    gtk_application_get_accels_for_action (GtkApplication *application,
                                           const gchar *detailed_action_name);

Gets the accelerators that are currently associated with the given action.

#### Parameters

application | a GtkApplication |
detailed_action_name | a detailed action name, specifying and action and target to obtain accelerators for |

#### Returns

accelerators for `detailed_action_name` , as a `NULL`-terminated array. Free with `g_strfreev()` when no longer needed.

[transfer full]

Since 3.12

### gtk_application_set_accels_for_action ()

    void
    gtk_application_set_accels_for_action (GtkApplication *application,
                                           const gchar *detailed_action_name,
                                           const gchar * const *accels);

Sets one or more keyboard accelerator that will trigger the given action. The first item in `accels` will be the primary accelerator, which may be displayed in the UI.

#### Parameters

application | a GtkApplication |
detailed_action_name | a detailed action name, specifying and action and target to associate accelerators with |
accels | a list of accelerators in the format understood by `gtk_accelerator_parse()`. | [array zero-terminated=1]

Since 3.12

## Types and Values

### struct GtkApplication

    struct GtkApplication;

### struct GtkApplicationClass

    struct GtkApplicationClass {
      GApplicationClass parent_class;

      void (*window_added)   (GtkApplication *application,
                              GtkWindow      *window);
      void (*window_removed) (GtkApplication *application,
                              GtkWindow      *window);
    };

#### Members

GApplicationClass `parent_class`; | The parent class. |
`window_added` () | Signal emitted when a GtkWindow is added to application through `gtk_application_add_window()`. |
`window_removed` () | Signal emitted when a GtkWindow is removed from application, either as a side-effect of being destroyed or explicitly through `gtk_application_remove_window()`. |

### enum GtkApplicationInhibitFlags

Types of user actions that may be blocked by `gtk_application_inhibit()`.

#### Members

GTK_APPLICATION_INHIBIT_LOGOUT | Inhibit ending the user session by logging out or by shutting down the computer |
GTK_APPLICATION_INHIBIT_SWITCH | Inhibit user switching |
GTK_APPLICATION_INHIBIT_SUSPEND | Inhibit suspending the session or computer |
GTK_APPLICATION_INHIBIT_IDLE | Inhibit the session being marked as idle (and possibly locked) |

Since 3.4

## Property Details

### The `“active-window”` property

      “active-window”            GtkWindow *

The window which most recently had focus.

Flags: Read

### The `“app-menu”` property

      “app-menu”                 GMenuModel *

The GMenuModel for the application menu.

Flags: Read / Write

### The `“menubar”` property

      “menubar”                  GMenuModel *

The GMenuModel for the menubar.

Flags: Read / Write

### The `“register-session”` property

      “register-session”         gboolean

Set this property to `TRUE` to register with the session manager.

Flags: Read / Write

Default value: FALSE

Since 3.4

## Signal Details

### The `“window-added”` signal

    void
    user_function (GtkApplication *application,
                   GtkWindow      *window,
                   gpointer        user_data)

Emitted when a GtkWindow is added to `application` through `gtk_application_add_window()`.

#### Parameters

application | the GtkApplication which emitted the signal |
window | the newly-added GtkWindow |
user_data | user data set when the signal handler was connected. |

Flags: Run First

Since 3.2

### The `“window-removed”` signal

    void
    user_function (GtkApplication *application,
                   GtkWindow      *window,
                   gpointer        user_data)

Emitted when a GtkWindow is removed from `application` , either as a side-effect of being destroyed or explicitly through `gtk_application_remove_window()`.

#### Parameters

application | the GtkApplication which emitted the signal |
window | the GtkWindow that is being removed |
user_data | user data set when the signal handler was connected. |

Flags: Run First

Since 3.2